!*****************************************************************!
!*                                                               *!
!*              4C (FORESEE) Simulation Model                    *!
!*                                                               *!
!*                    Subroutines for:                           *!
!*                                                               *!
!*    - topmenu_win:   calls the dialog windows					 *!
!*					   controls the application flow	         *!
!*                                                               *!
!*                                                               *!
!*                                                               *!
!*   - control functions: forward - ok button control			 *!
!*						  cancel - exits the application, cancel *!
!*								   button						 *!
!*                        stepback - back button control		 *!
!*                                                               *!
!*                                                               *!
!*                                                               *!                 
!*****************************************************************!
!*
!*  Implementation and Revisions:
!*  -----------------------------
!
! Latest changes:
!
!  date     who what
!  -------------------------------------------------------------
!
!  07.01.16 Su Start: Lnge filename angepasst f. GetFile/FileOpen
!  05.07.05 Su Start: outtest vor ApplControl aufrufen
!  17.05.05 Su ApplControl: Dim. flagsave auf 23 erhoeht
!              Start: actDir nach GetFile reaktivieren
!  24.03.05 ag outtest in before starting the simulation added after call readsim
!  04.01.05 ag winpath added after call readsim
!  25.11.04 ag 4C dialog included into the main dialog
!  03.11.04 ag "default directory" dialog added
!  08.10.04 ag "create control file" deleted
!  06.10.04 ag check outtest in "start with control file"
!  28.09.04 ag save button function
!  08.09.04 ag module flag_field in use
!  31.08.04 ag runnr-button controls added
!  26.08.04 ag resource.* replaced by 4C_dialogs.*
!  25.08.04 ag only control functions left
!  24.08.04 ag ouput and writesim changes (su) added
!  23.08.04 ag save dialog added, su changes merged
!  17.08.04 Su output methods added
!  17.08.04 ag comments added
!
!

SUBROUTINE topmenu_win 

USE dflogm

INCLUDE '4C_dialogs.fd'

TYPE (DIALOG)  dlg_main
integer(4) retint

	call InitMain(dlg_main)
!	retint = DlgModal(dlg_main)   ! nach InitMain verschoben

end subroutine topmenu_win


!***************************************************************
!****** Control Functions **************************************
!***************************************************************
SUBROUTINE Start ( dlg, id, callbacktype )

use dflogm
use dflib

use data_simul
use data_stand
use flag_field


implicit none

type (dialog) dlg, dlg_default_dir
integer id
integer callbacktype
integer retint

include '4C_dialogs.fd'

logical retlog, push_state
character :: text = 'Simulation control file: '
character :: text_mes = 'Measurement file: '
integer id_ctr
!Settings for FileOpen
character*(*),parameter :: filter_spec = &
						  "Simulation control files (*.sim)"C//"*.sim"C// &
						"All Files (*)"C//"*"C//""C
character(512) filename

logical retdir
	
	! get the radio button before the dlg was closed
	retlog = DlgGet( dlg, IDC_RADIO_start, push_state ) 
	if (push_state) id_ctr = IDC_RADIO_start
	
!	retlog = DlgGet( dlg, IDC_RADIO_start_dir, push_state ) 
!	if (push_state) id_ctr = IDC_RADIO_start_dir
	
	retlog = DlgGet( dlg, IDC_RADIO_edit, push_state ) 
	if (push_state) id_ctr = IDC_RADIO_edit
	
	
!	select case (id_ctr)
!
!	  case (IDC_RADIO_start)
		! get the control file
		call GetFileF (filename, filter_spec, text)
        retdir = changedirqq (actdir)
		simfile = filename
		call readsim
		call winPath
		call outtest
		print *, '----------------------------------'
		print *, '---- Start simulation... ---------'	
	!	simulation
		call sim_control
		
        call deallofile
		
!	  case (IDC_RADIO_start_dir)
!		! get the directory
!		call InitDefaultDir(dlg_default_dir)
!			! call EditCtrFile(dlg_ctr)
!			! call SetRunCombo(dlg_ctr)
!		retint = DLGModal(dlg_default_dir)
!		! get the control file
!		call GetFileF (filename, filter_spec, text)
!        retdir = changedirqq (actdir)
!		simfile = filename
!		call readsim
!		call winPath
!!		call outtest
!		print *, '----------------------------------'
!		print *, '---- Start simulation... ---------'	
!	!	simulation
!		call sim_control
!		call deallofile
!
!
!	  case (IDC_RADIO_edit)
!		! get the directory
!		call InitDefaultDir(dlg_default_dir)
!			! call EditCtrFile(dlg_ctr)
!			! call SetRunCombo(dlg_ctr)
!		retint = DLGModal(dlg_default_dir)
!!        retdir = changedirqq (actdir)
! 		call GetFile (filename, filter_spec, text)
!        retdir = changedirqq (actdir)
!        simfile = filename
!		! simulation
!	    call readsim
!		call winPath
!		call outtest	! Vorziehen wegen Belegung output-Felder
!!		call deallofile
!
!				
!		! start the application
!		call ApplControl
!
!	end select
	
	if ( allocated(flagsave)) deallocate(flagsave)

    print *, '4C end'
 
END SUBROUTINE Start


!**************************************************************************************

!SUBROUTINE ApplControl
!
!USE dflogm
!use data_simul
!use data_stand
!use flag_field
!use data_general_dlg
!
!INCLUDE '4C_dialogs.fd'
!
!TYPE (DIALOG)  dlg_4c, dlg_ctr, dlg_files, dlg_ids, dlg_out, dlg, dlg_flags, dlg_default_dir
!TYPE (DIALOG)  dlg_yearly, dlg_yearly_coh, dlg_daily, dlg_daily_coh
!INTEGER(4)     retint
!LOGICAL        retlog, is_checked, push_state 
!CHARACTER(256) text
!
!
!integer id
!integer callbacktype
!
!logical ex
!character(4) textCtr, helpsim
!
!!Settings for FileOpen
!character*512 :: filename 
!character dir
!
!character*(512):: filter_spec
!character(150) :: sim_filename
!
!
!
!external Forward, Cancel
!	
!	! allocation of flag fields (nr. of flags, run nr.)
!	allocate (flagsave(23, site_nr))
!	call flags_ini()
!	call StructureToFlags()
!
!	! sets the output directory 
!	call act_dir(dir)
!
!	! start, choose option
!	call InitCtr(dlg_ctr)
!	call InitFiles(dlg_files)
!	call InitFlags(dlg_flags)
!	call InitIds(dlg_ids)
!	call InitOut(dlg_out)
!	call InitYearlyOut(dlg_yearly)
!	call InitCohyOut(dlg_yearly_coh)
!	call InitDailyOut(dlg_daily)
!	call InitCohdOut(dlg_daily_coh)
!
!
!!	retint = DlgModalWithParent(dlg_4c, IDD_4C_main)
!!	retint = DlgModal(dlg_4c)
!	
!	retint = ID_DEFAULT_DIR_BUTTON_OK
!
!do while ( (retint .ne. ID_START) .and. (retint .ne. IDCANCEL)) 
!
!!print *, 'retint   ', retint
!	
!	select case (retint)
!
!		case (ID_DEFAULT_DIR_BUTTON_OK)
!			call EditCtrFile(dlg_ctr)
!			call SetRunCombo(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!		case (ID_CTR_BUTTON_RUNNR)	
!			retint = DlgModal(dlg_ctr)
!		
!		case (ID_CTR_BUTTON_FILES)	
!			call EditFileSpec(dlg_files)
!			call EditStandId(dlg_files)
!			retint = DlgModal(dlg_files)
!
!		case (ID_CTR_BUTTON_FLAGS)	
!			call SetModelSpec ( dlg_flags)
!			!call EditFileSpec(dlg_flags)
!			retint = DlgModal(dlg_flags)
!
!		case (ID_CTR_BUTTON_IDS)	
!			call SetRunIds(dlg_ids)
!			!call EditFileSpec(dlg_flags)
!			retint = DlgModal(dlg_ids)
!
!			
!		case (ID_CTR_BUTTON_OK)
!			call EditOutFile(dlg_out)
!			call EditOuts(dlg_out)
!			retint = DlgModal(dlg_out)
!	
!		!case (ID_Ctr_Button_Back)			
!
!		case (ID_FILES_BUTTON_OK)
!			call EditCtrFile(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!		case (ID_FLAGS_BUTTON_OK)
!			call EditCtrFile(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!		case (ID_CANCEL_FILES)
!			call EditCtrFile(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!		case (ID_CANCEL_FLAGS)
!			call EditCtrFile(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!		case (ID_CANCEL_IDS)
!			call EditCtrFile(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!!		case (ID_CANCEL_OUT)
!!			call EditCtrFile(dlg_ctr)
!!			retint = DLGModal(dlg_ctr)
!
!		case (ID_CANCEL_OUTF)
!!			call EditCtrFile(dlg_ctr)
!!			retint = DLGModal(dlg_ctr)
!			call EditOuts(dlg_out)
!			retint = DlgModal(dlg_out)
!
!		case (ID_IDS_BUTTON_OK)
!			call EditCtrFile(dlg_ctr)
!			call SetRunCombo(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!		
!		case (ID_OUT_BUTTON_BACK)
!			call EditCtrFile(dlg_ctr)
!			retint = DLGModal(dlg_ctr)
!
!			
!		case (ID_SAVE)
!			filter_spec = "Simulation file (*.sim)"C//"*.sim"C// &
!                      "All Files (*.*)"C//"*.*"C//""C
!					  !"Stand initialisation files (*.ini)"C//"*.ini"C// &
!                      !"All Files (*.*)"C//"*.*"C//""C
!			call FileSave (sim_filename, filter_spec) 
!			call writesim(sim_filename)
!			retint = DLGModal(dlg_out)
!
!
!		!output dialogs 
!		case (IDC_BUTTON_coh_daily)
!            call EditCohdOut(dlg_daily_coh)
!			retint = DLGModal(dlg_daily_coh)
!
!		case (IDC_BUTTON_daily)
!            call EditDailyOut(dlg_daily)
!			retint = DLGModal(dlg_daily)
!
!		case (IDC_BUTTON_coh_yearly)
!            call EditCohyOut(dlg_yearly_coh)
!			retint = DLGModal(dlg_yearly_coh)
!			
!		case (IDC_BUTTON_yearly)
!            call EditYearlyOut(dlg_yearly)
!			retint = DLGModal(dlg_yearly)
!
!
!		! ok buttons for output dialogs
!		case (ID_DAILYCOH_BUTTON_OK)
!			call UpdateCohdOut(dlg_daily_coh)
!			call EditOuts(dlg_out)
!			retint = DlgModal(dlg_out)
!	
!		case (ID_YEARLYCOH_BUTTON_OK)
!			call UpdateCohyOut(dlg_yearly_coh)
!			call EditOuts(dlg_out)
!			retint = DlgModal(dlg_out)
!	
!		case (ID_DAILY_BUTTON_OK)
!			call UpdateDailyOut(dlg_daily)
!			call EditOuts(dlg_out)
!			retint = DlgModal(dlg_out)
!
!		case (ID_YEARLY_BUTTON_OK)
!			call UpdateYearlyOut(dlg_yearly)
!			call EditOuts(dlg_out)
!			retint = DlgModal(dlg_out)
!
!
!	end select
!end do
!
!	! uninit the dialog frames
! 	call DlgUninit( dlg_ctr )
!	call DlgUninit( dlg_files )
!	call DlgUninit( dlg_out )
!	call DlgUninit( dlg_flags )
!	call DlgUninit( dlg_yearly )
!	call DlgUninit( dlg_yearly_coh )
!	call DlgUninit( dlg_daily )
!	call DlgUninit( dlg_daily_coh )
!
!	select case (retint)
!		case (ID_START)
!			! call outtest
!			print *, '----------------------------------'
!			print *, '---- Start simulation... ---------'	
!		!	simulation
!!			call outtest
!			call sim_control
!			call deallofile
!
!		case (IDCANCEL)
!			call deallofile
!			! call finish_simul
!			call finish_all
!	
!	end select	
!
!
!END subroutine ApplControl
!
!
!***************************************************************
!SUBROUTINE StepBack ( dlg, id, callbacktype )
!
!use dflogm
!
!use data_simul
!use data_stand
!
!implicit none
!type (dialog) dlg
!integer id
!integer callbacktype
!integer retint
!!character(20) text, helpsim
!
!include '4C_dialogs.fd'
!
!logical retlog, push_state
!
!    ! supress compiler warnings for unreferenced arguments
!	integer local_id, local_callbacktype
!	local_id = id
!	local_callbacktype = callbacktype
!
!	! choose which frame called
!	select case (id)
!
!!	case (ID_CTR_BUTTON_BACK)		
!!		call DLGSetReturn(dlg ,ID_CTR_BUTTON_BACK)
!!		call DlgExit(dlg)
!		
!		
!	case (ID_OUT_BUTTON_BACK)
!		call DLGSetReturn(dlg ,ID_OUT_BUTTON_BACK)
!		call DlgExit(dlg)
!
!   end select
! 
!END SUBROUTINE StepBack
!
!
!
!
!!***************************************************************
!
!SUBROUTINE Forward ( dlg, id, callbacktype )
!
!use dflogm
!
!use data_out
!use data_simul
!use data_stand
!use flag_field
!use data_general_dlg
!
!implicit none
!type (dialog) dlg
!!integer act_run
!integer id
!integer callbacktype
!integer retint 
!character(20) text, helpsim
!
!include '4C_dialogs.fd'
!
!logical retlog, push_state
!
!    ! supress compiler warnings for unreferenced arguments
!integer local_id, local_callbacktype
!	local_id = id
!	local_callbacktype = callbacktype
!
!	!print *, 'FORWARD id = ' , id
!
!
!	! choose which frame called
!	select case (id)
!	
!	case (ID4C_BUTTON_OK)
!		call DLGSetReturn(dlg ,ID4C_BUTTON_OK)
!		call DLGExit(dlg)
!
!
!	case (ID_DEFAULT_DIR_BUTTON_OK)
!		call DefaultDirSpec(dlg)
!		call DLGExit(dlg)
!
!
!	case (ID_CTR_BUTTON_OK)
!		! sets the text in the combo boxes
!		call EditRunOption ( dlg, id, callbacktype )
!		call DLGSetReturn(dlg, ID_CTR_BUTTON_OK)
!		call DlgExit(dlg)
!	    
!	case (ID_CTR_BUTTON_RUNNR)	
!			call UpdateRunNr(dlg)
!			call DLGSetReturn(dlg, ID_CTR_BUTTON_RUNNR)
!			call DlgExit(dlg)
!
!	case (ID_CTR_BUTTON_FLAGS)
!		! get run
!		retlog = DlgGet(dlg, IDC_COMBO_runv3, text)
!		text = adjustl(text)
!		text = text(1:2)
!		read (text, *) act_run
!		call DLGSetReturn(dlg, ID_CTR_BUTTON_FLAGS)
!		call DlgExit(dlg)
!
!	case (ID_CTR_BUTTON_FILES)
!		! get run
!		retlog = DlgGet(dlg, IDC_COMBO_runv3, text)
!		text = adjustl(text)
!		text = text(1:2)
!		read (text, *) act_run
!		call DLGSetReturn(dlg, ID_CTR_BUTTON_FILES)
!		call DlgExit(dlg)
!
!	case (ID_CTR_BUTTON_IDS)
!		retlog = DlgGet(dlg, IDC_COMBO_runv3, text)
!		text = adjustl(text)
!		text = text(1:2)
!		read (text, *) act_run
!		call DLGSetReturn(dlg, ID_CTR_BUTTON_IDS)
!		call DlgExit(dlg)
!
!	
!	case (ID_FILES_BUTTON_OK)
!		! read the stand identifier	    
!		
!		call StoreFileSpec(dlg)
!		call DLGSetReturn(dlg ,ID_FILES_BUTTON_OK)
!		call DlgExit(dlg)
!
!
!	case (ID_FLAGS_BUTTON_OK)
!		call StoreFlagSpec(dlg)
!		call DLGSetReturn(dlg ,ID_FLAGS_BUTTON_OK)
!		call DlgExit(dlg)
!
!	case (ID_IDS_BUTTON_OK)
!		call GetRunIds(dlg)
!		call DLGSetReturn(dlg ,ID_IDS_BUTTON_OK)
!		call DlgExit(dlg)
!
!
!	! show output dialog     
!	case (IDC_BUTTON_coh_daily)
!		call EditOutFlags(dlg)
!		call DLGSetReturn(dlg ,IDC_BUTTON_coh_daily)
!		call DlgExit(dlg)
!        
!	case (IDC_BUTTON_daily)
!		call EditOutFlags(dlg)
!		call DLGSetReturn(dlg ,IDC_BUTTON_daily)
!		call DlgExit(dlg)
!    
!	case (IDC_BUTTON_coh_yearly)
!		call EditOutFlags(dlg)
!		call DLGSetReturn(dlg ,IDC_BUTTON_coh_yearly)
!		call DlgExit(dlg)
!    
!	case (IDC_BUTTON_yearly)
!		call EditOutFlags(dlg)
!		call DLGSetReturn(dlg ,IDC_BUTTON_yearly)
!		call DlgExit(dlg)
!
!
!    ! select/deselect Files
!    case (ID_YEARLY_BUTTON_SELECT)
!!        print *, ' *** Forward: Button SELECT'
!        time_out = 1
!        outy%out_flag = 1
!        call EditYearlyOut( dlg )
!
!    case (ID_YEARLY_BUTTON_DESELECT)
!!        print *, ' *** Forward: Button DESELECT'
!        time_out      = 0
!        outy%out_flag = 0
!        call EditYearlyOut( dlg )
!!		call EditYearlyOutDeSel(dlg)
!
!    case (ID_DAILY_BUTTON_SELECT)
!        flag_dayout   = 1
!        outd%out_flag = 1
!        call EditDailyOut( dlg )
!
!    case (ID_DAILY_BUTTON_DESELECT)
!        flag_dayout   = 0
!        outd%out_flag = 0
!        call EditDailyOut( dlg )
!
!    case (ID_DAILYCOH_BUTTON_SELECT)
!        flag_cohoutd  = 1
!        outcd%out_flag = 1
!        call EditCohdOut( dlg )
!
!    case (ID_DAILYCOH_BUTTON_DESELECT)
!        flag_cohoutd  = 0
!        outcd%out_flag = 0
!        call EditCohdOut( dlg )
!
!    case (ID_YEARLYCOH_BUTTON_SELECT)
!        flag_cohouty  = 1
!        outcy%out_flag = 1
!        call EditCohyOut( dlg )
!
!    case (ID_YEARLYCOH_BUTTON_DESELECT)
!        flag_cohouty  = 0
!        outcy%out_flag = 0
!        call EditCohyOut( dlg )
!
!
!   	! close output dialogs, got to dlg_out    
!	case (ID_DAILYCOH_BUTTON_OK)
!		call DLGSetReturn(dlg ,ID_DAILYCOH_BUTTON_OK)
!		call DlgExit(dlg)
!        
!	case (ID_DAILY_BUTTON_OK)
!		call DLGSetReturn(dlg ,ID_DAILY_BUTTON_OK)
!		call DlgExit(dlg)
!    
!	case (ID_YEARLYCOH_BUTTON_OK)
!		call DLGSetReturn(dlg ,ID_YEARLYCOH_BUTTON_OK)
!		call DlgExit(dlg)
!    
!	case (ID_YEARLY_BUTTON_OK)
!		call DLGSetReturn(dlg ,ID_YEARLY_BUTTON_OK)
!		call DlgExit(dlg)
!
!	! save the changes
!	case (ID_SAVE)
!		call FlagsToStructure()
!
!		call DLGSetReturn(dlg ,ID_SAVE)
!		call DlgExit(dlg)
!		    
!	! start simulation
!	case (ID_START)
!		call FlagsToStructure()
!		call DLGSetReturn(dlg ,ID_START)
!		call DlgExit(dlg)
!    
!
!   end select
!
!
!END SUBROUTINE Forward
!
!

!***************************************************************

SUBROUTINE Cancel ( dlg, id, callbacktype )

use dflogm

use data_simul
use data_stand

implicit none
type (dialog) dlg
integer id
integer callbacktype
integer retint


include '4C_dialogs.fd'

logical retlog, push_state

    ! supress compiler warnings for unreferenced arguments
	integer local_id, local_callbacktype
	local_id = id
	local_callbacktype = callbacktype

	select case(id)

	case (ID_CANCEL_FLAGS) 
		call DlgSetReturn(dlg, ID_CANCEL_FLAGS)
		call DlgExit(dlg)

	case (ID_CANCEL_FILES)
		call DlgSetReturn(dlg, ID_CANCEL_FILES)
		call DlgExit(dlg)

	case (ID_CANCEL_IDS)
		call DlgSetReturn(dlg, ID_CANCEL_IDS)
		call DlgExit(dlg)

!	case (ID_CANCEL_OUT)	
!		call DLGSetReturn(dlg ,ID_CANCEL_OUT)
!		call DlgExit(dlg)

	case (ID_CANCEL_OUTF)	
		call DLGSetReturn(dlg ,ID_CANCEL_OUTF)
		call DlgExit(dlg)

	case (IDCANCEL)	
		call DLGSetReturn(dlg ,IDCANCEL)
		call DlgExit(dlg)
	
	case (IDSTOP)
		print *, ''
		print *, '---------------------------------------------'
		stop ' -------Program terminated by the user.------'

	end select

END SUBROUTINE Cancel
