!*****************************************************************!
!*                                                               *!
!*              4C (FORESEE) Simulation Model                    *!
!*                                                               *!
!*                    Subroutines for:                           *!
!*                   - windows shell -                           *!
!*                                                               *!
!*  contains:                                                    *!
!*   UpdateYearlyOut                                             *!
!*   GetCheckOut                                                 *!
!*   UpdateDailyOut                                              *!
!*   UpdateCohyOut                                               *!
!*                                                               *!
!*                                                               *!
!*****************************************************************!
!*
!*  Implementation and Revisions:
!*  -----------------------------  
!
!  07.01.16 Su GetCheckOut: outa mit dimension outy_n anlegen
!  28.10.11 Su UpdateCohyOut erweitert
!              GetCheckOut: outa vergrert  
!  18.08.11 Su UpdateDailyOut, UpdateCohyOut, UpdateCohdOut erweitert
!  17.08.11 Su UpdateYearlyOut erweitert
!  01.08.05 Su Update...Out bearbeitet
!  05.07.05 Su UpdateDailyOut: Korrektur ndvar
!  25.01.05 ag combo boxes moved to dlg_out
!***************************************************************

SUBROUTINE UpdateYearlyOut( dlg )

use dflogm
USE DFLIB

use data_out
use data_simul

implicit none

type (dialog) dlg
integer retint, num, i, nflag, actflag
!logical check_state
character(20) text, helpsim
!character(90), dimension(5) :: charflag

external Cancel, Forward

include '4C_dialogs.fd'

logical retlog

 nyvar = 1
 if (time_out .gt. 0) then
   call GetCheckOut(dlg, IDC_CHECK_y1, outy, nyvar, 1)
   call GetCheckOut(dlg, IDC_CHECK_y2, outy, nyvar, 2)
   call GetCheckOut(dlg, IDC_CHECK_y3, outy, nyvar, 3)
   call GetCheckOut(dlg, IDC_CHECK_y4, outy, nyvar, 4)
   call GetCheckOut(dlg, IDC_CHECK_y5, outy, nyvar, 5)
   call GetCheckOut(dlg, IDC_CHECK_y6, outy, nyvar, 6)
   call GetCheckOut(dlg, IDC_CHECK_y7, outy, nyvar, 7)
   call GetCheckOut(dlg, IDC_CHECK_y8, outy, nyvar, 8)
   call GetCheckOut(dlg, IDC_CHECK_y9, outy, nyvar, 9)
   call GetCheckOut(dlg, IDC_CHECK_y10, outy, nyvar, 10)
   call GetCheckOut(dlg, IDC_CHECK_y11, outy, nyvar, 11)
   call GetCheckOut(dlg, IDC_CHECK_y12, outy, nyvar, 12)
   call GetCheckOut(dlg, IDC_CHECK_y13, outy, nyvar, 13)
   call GetCheckOut(dlg, IDC_CHECK_y14, outy, nyvar, 14)
   call GetCheckOut(dlg, IDC_CHECK_y15, outy, nyvar, 15)
   call GetCheckOut(dlg, IDC_CHECK_y16, outy, nyvar, 16)
   call GetCheckOut(dlg, IDC_CHECK_y17, outy, nyvar, 17)
   call GetCheckOut(dlg, IDC_CHECK_y18, outy, nyvar, 18)
   call GetCheckOut(dlg, IDC_CHECK_y19, outy, nyvar, 19)
   call GetCheckOut(dlg, IDC_CHECK_y20, outy, nyvar, 20)
   call GetCheckOut(dlg, IDC_CHECK_y21, outy, nyvar, 21)
   call GetCheckOut(dlg, IDC_CHECK_y22, outy, nyvar, 22)
   call GetCheckOut(dlg, IDC_CHECK_y23, outy, nyvar, 23)
   call GetCheckOut(dlg, IDC_CHECK_y24, outy, nyvar, 24)
   call GetCheckOut(dlg, IDC_CHECK_y25, outy, nyvar, 25)
   call GetCheckOut(dlg, IDC_CHECK_y26, outy, nyvar, 26)
   call GetCheckOut(dlg, IDC_CHECK_y27, outy, nyvar, 27)
   call GetCheckOut(dlg, IDC_CHECK_y28, outy, nyvar, 28)
   call GetCheckOut(dlg, IDC_CHECK_y29, outy, nyvar, 29)
   call GetCheckOut(dlg, IDC_CHECK_y30, outy, nyvar, 30)
   call GetCheckOut(dlg, IDC_CHECK_y31, outy, nyvar, 31)
   call GetCheckOut(dlg, IDC_CHECK_y32, outy, nyvar, 32)
   call GetCheckOut(dlg, IDC_CHECK_y33, outy, nyvar, 33)
   call GetCheckOut(dlg, IDC_CHECK_y34, outy, nyvar, 34)
   call GetCheckOut(dlg, IDC_CHECK_y35, outy, nyvar, 35)
   call GetCheckOut(dlg, IDC_CHECK_y36, outy, nyvar, 36)
   call GetCheckOut(dlg, IDC_CHECK_y37, outy, nyvar, 37)
 
    if (nyvar .le. 1) then
      write(*,*) '  All yearly output files selected '
      do i = 1,outy_n
         outy(i)%out_flag = 1
      enddo
    endif
 else
   outy%out_flag = 0
   out_flag_light = 0
 endif

END SUBROUTINE UpdateYearlyOut

!***************************************************************

SUBROUTINE GetCheckOut(dlg, id, outa, nnvar, inum)

! Update output-file (Check-Box) 
use dflogm
USE DFLIB

use data_out
use data_simul

implicit none

type (dialog) dlg
integer id, nnvar
!integer callbacktype
integer inum
logical check_state
logical retlog
type (out_struct),dimension(outy_n),target :: outa   !  information about output files

include '4C_dialogs.fd'

!    retlog = DlgSet(dlg, id, outa(inum)%kind_name//' - '//outa(inum)%f_line(3:)) 
    retlog = DlgGet(dlg, id, check_state) 

    if (check_state) then
         nnvar = nnvar + 1
         select case (outa(inum)%kind_name)
         case ('litter')
            outa(inum)%out_flag = 2
          case ('dips')
            outa(inum)%out_flag = 2
          case ('gsdps')
            outa(inum)%out_flag = 2
          case ('dtr')
            outa(inum)%out_flag = 2
          case ('trman')
            outa(inum)%out_flag = 2

         case default
            outa(inum)%out_flag = 1
         end select
    else
       outa(inum)%out_flag = 0
    endif


END SUBROUTINE GetCheckOut

!***************************************************************

SUBROUTINE UpdateDailyOut( dlg )

! check daily output files

use dflogm
USE DFLIB

use data_out
use data_simul

implicit none

type (dialog) dlg
integer retint, num, i, nflag, actflag
!logical check_state
character(20) text, helpsim
character(90), dimension(5) :: charflag
character a

external Cancel, Forward

include '4C_dialogs.fd'

logical retlog


 ndvar = 1
 if (flag_dayout .gt. 0) then
   call GetCheckOut(dlg, IDC_CHECK_y1, outd, ndvar, 1)
   call GetCheckOut(dlg, IDC_CHECK_y2, outd, ndvar, 2)
   call GetCheckOut(dlg, IDC_CHECK_y3, outd, ndvar, 3)
   call GetCheckOut(dlg, IDC_CHECK_y4, outd, ndvar, 4)
   call GetCheckOut(dlg, IDC_CHECK_y5, outd, ndvar, 5)
   call GetCheckOut(dlg, IDC_CHECK_y6, outd, ndvar, 6)
   call GetCheckOut(dlg, IDC_CHECK_y7, outd, ndvar, 7)
   call GetCheckOut(dlg, IDC_CHECK_y8, outd, ndvar, 8)
   call GetCheckOut(dlg, IDC_CHECK_y9, outd, ndvar, 9)
   call GetCheckOut(dlg, IDC_CHECK_y10, outd, ndvar, 10)
   call GetCheckOut(dlg, IDC_CHECK_y11, outd, ndvar, 11)
   call GetCheckOut(dlg, IDC_CHECK_y12, outd, ndvar, 12)
   call GetCheckOut(dlg, IDC_CHECK_y13, outd, ndvar, 13)
   call GetCheckOut(dlg, IDC_CHECK_y14, outd, ndvar, 14)
   call GetCheckOut(dlg, IDC_CHECK_y15, outd, ndvar, 15)
   call GetCheckOut(dlg, IDC_CHECK_y16, outd, ndvar, 16)
   call GetCheckOut(dlg, IDC_CHECK_y17, outd, ndvar, 17)
   call GetCheckOut(dlg, IDC_CHECK_y18, outd, ndvar, 18)
   call GetCheckOut(dlg, IDC_CHECK_y19, outd, ndvar, 19)
 
    if (ndvar .le. 1) then
      write(*,*) '  All daily output files selected '
      do i = 1,outd_n
         outd(i)%out_flag = 1
      enddo
    endif
    ! check daily output
    if (year > 5 .and. flag_dayout .ge. 1) then
       write(*,*) '  Warning: Your choice of daily output is ON with a simulation time of'
       write(*,'(I6,A,I8,A)') year,'  years. This option will create ',365*year,' data records per file!'
       write(*,'(A)',advance='no') '  Do you really want do use daily output (y/n)? '
       read *,a
       IF (a .eq. 'n' .or. a .eq. 'N') then
          flag_dayout = 0
       ENDIF
    ENDIF
 else
   outd%out_flag = 0
 endif

END SUBROUTINE UpdateDailyOut

!***************************************************************

SUBROUTINE UpdateCohyOut( dlg )

! check yearly cohort output files

use dflogm
USE DFLIB

use data_out
use data_simul

implicit none

type (dialog) dlg
integer retint, num, i, nflag
!logical check_state
character(20) text, helpsim
character(90), dimension(5) :: charflag

external Cancel, Forward

include '4C_dialogs.fd'

logical retlog

 ncvar = 1
 if (flag_cohouty .gt. 0) then
   flag_cohout = 1
   call GetCheckOut(dlg, IDC_CHECK_y1, outcy, ncvar, 1)
   call GetCheckOut(dlg, IDC_CHECK_y2, outcy, ncvar, 2)
   call GetCheckOut(dlg, IDC_CHECK_y3, outcy, ncvar, 3)
   call GetCheckOut(dlg, IDC_CHECK_y4, outcy, ncvar, 4)
   call GetCheckOut(dlg, IDC_CHECK_y5, outcy, ncvar, 5)
   call GetCheckOut(dlg, IDC_CHECK_y6, outcy, ncvar, 6)
   call GetCheckOut(dlg, IDC_CHECK_y7, outcy, ncvar, 7)
   call GetCheckOut(dlg, IDC_CHECK_y8, outcy, ncvar, 8)
   call GetCheckOut(dlg, IDC_CHECK_y9, outcy, ncvar, 9)
   call GetCheckOut(dlg, IDC_CHECK_y10, outcy, ncvar, 10)
   call GetCheckOut(dlg, IDC_CHECK_y11, outcy, ncvar, 11)
   call GetCheckOut(dlg, IDC_CHECK_y12, outcy, ncvar, 12)
   call GetCheckOut(dlg, IDC_CHECK_y13, outcy, ncvar, 13)
   call GetCheckOut(dlg, IDC_CHECK_y14, outcy, ncvar, 14)
   call GetCheckOut(dlg, IDC_CHECK_y15, outcy, ncvar, 15)
   call GetCheckOut(dlg, IDC_CHECK_y16, outcy, ncvar, 16)
   call GetCheckOut(dlg, IDC_CHECK_y17, outcy, ncvar, 17)
   call GetCheckOut(dlg, IDC_CHECK_y18, outcy, ncvar, 18)
   call GetCheckOut(dlg, IDC_CHECK_y19, outcy, ncvar, 19)
   call GetCheckOut(dlg, IDC_CHECK_y20, outcy, ncvar, 20)
   call GetCheckOut(dlg, IDC_CHECK_y21, outcy, ncvar, 21)
   call GetCheckOut(dlg, IDC_CHECK_y22, outcy, ncvar, 22)
   call GetCheckOut(dlg, IDC_CHECK_y23, outcy, ncvar, 23)
   call GetCheckOut(dlg, IDC_CHECK_y24, outcy, ncvar, 24)
   call GetCheckOut(dlg, IDC_CHECK_y25, outcy, ncvar, 25)
   call GetCheckOut(dlg, IDC_CHECK_y26, outcy, ncvar, 26)
   call GetCheckOut(dlg, IDC_CHECK_y27, outcy, ncvar, 27)
   call GetCheckOut(dlg, IDC_CHECK_y28, outcy, ncvar, 28)
   call GetCheckOut(dlg, IDC_CHECK_y29, outcy, ncvar, 29)
   call GetCheckOut(dlg, IDC_CHECK_y30, outcy, ncvar, 30)
   call GetCheckOut(dlg, IDC_CHECK_y31, outcy, ncvar, 31)
   call GetCheckOut(dlg, IDC_CHECK_y32, outcy, ncvar, 32)
   call GetCheckOut(dlg, IDC_CHECK_y33, outcy, ncvar, 33)
   call GetCheckOut(dlg, IDC_CHECK_y34, outcy, ncvar, 34)
   call GetCheckOut(dlg, IDC_CHECK_y35, outcy, ncvar, 35)
   call GetCheckOut(dlg, IDC_CHECK_y36, outcy, ncvar, 36)
   call GetCheckOut(dlg, IDC_CHECK_y37, outcy, ncvar, 37)
   call GetCheckOut(dlg, IDC_CHECK_y38, outcy, ncvar, 38)
   call GetCheckOut(dlg, IDC_CHECK_y39, outcy, ncvar, 39)
   call GetCheckOut(dlg, IDC_CHECK_y40, outcy, ncvar, 40)
   call GetCheckOut(dlg, IDC_CHECK_y41, outcy, ncvar, 41)
   call GetCheckOut(dlg, IDC_CHECK_y42, outcy, ncvar, 42)
   call GetCheckOut(dlg, IDC_CHECK_y43, outcy, ncvar, 43)
   call GetCheckOut(dlg, IDC_CHECK_y44, outcy, ncvar, 44)
   call GetCheckOut(dlg, IDC_CHECK_y45, outcy, ncvar, 45)
   call GetCheckOut(dlg, IDC_CHECK_y46, outcy, ncvar, 46)
   call GetCheckOut(dlg, IDC_CHECK_y47, outcy, ncvar, 47)
   call GetCheckOut(dlg, IDC_CHECK_y48, outcy, ncvar, 48)
   call GetCheckOut(dlg, IDC_CHECK_y49, outcy, ncvar, 49)
   call GetCheckOut(dlg, IDC_CHECK_y50, outcy, ncvar, 50)
   call GetCheckOut(dlg, IDC_CHECK_y51, outcy, ncvar, 51)
 
    if (ncvar .le. 1) then
      write(*,*) '  All yearly output files of cohorts selected '
      do i = 1,outcy_n
         outcy(i)%out_flag = 1
      enddo
    endif
 else
   if (flag_cohoutd .eq. 0) flag_cohout = 0
   outcy%out_flag = 0
 endif

END SUBROUTINE UpdateCohyOut

!***************************************************************

SUBROUTINE UpdateCohdOut( dlg )

! check daily cohort output files

use dflogm
USE DFLIB

use data_out
use data_simul

implicit none

type (dialog) dlg
integer retint, num, i, nflag
!logical check_state
character(20) text, helpsim
character(90), dimension(5) :: charflag
character a

external Cancel, Forward

include '4C_dialogs.fd'

logical retlog

 ncdvar = 1
 if (flag_cohoutd .gt. 0) then
   flag_cohout = 1
   call GetCheckOut(dlg, IDC_CHECK_y1, outcd, ncdvar, 1)
   call GetCheckOut(dlg, IDC_CHECK_y2, outcd, ncdvar, 2)
   call GetCheckOut(dlg, IDC_CHECK_y3, outcd, ncdvar, 3)
   call GetCheckOut(dlg, IDC_CHECK_y4, outcd, ncdvar, 4)
   call GetCheckOut(dlg, IDC_CHECK_y5, outcd, ncdvar, 5)
   call GetCheckOut(dlg, IDC_CHECK_y6, outcd, ncdvar, 6)
   call GetCheckOut(dlg, IDC_CHECK_y7, outcd, ncdvar, 7)
   call GetCheckOut(dlg, IDC_CHECK_y8, outcd, ncdvar, 8)
   call GetCheckOut(dlg, IDC_CHECK_y9, outcd, ncdvar, 9)
   call GetCheckOut(dlg, IDC_CHECK_y10, outcd, ncdvar, 10)
   call GetCheckOut(dlg, IDC_CHECK_y11, outcd, ncdvar, 11)
   call GetCheckOut(dlg, IDC_CHECK_y12, outcd, ncdvar, 12)
   call GetCheckOut(dlg, IDC_CHECK_y13, outcd, ncdvar, 13)
   call GetCheckOut(dlg, IDC_CHECK_y14, outcd, ncdvar, 14)
   call GetCheckOut(dlg, IDC_CHECK_y15, outcd, ncdvar, 15)
   call GetCheckOut(dlg, IDC_CHECK_y16, outcd, ncdvar, 16)
   call GetCheckOut(dlg, IDC_CHECK_y17, outcd, ncdvar, 17)
   call GetCheckOut(dlg, IDC_CHECK_y18, outcd, ncdvar, 18)
   call GetCheckOut(dlg, IDC_CHECK_y19, outcd, ncdvar, 19)
 
    if (ncdvar .le. 1) then
      write(*,*) '  All daily output files of cohorts selected '
!      do i = 1,outd_n
!         outcd(i)%out_flag = 1
!      enddo
         outcd%out_flag = 1
    endif
    ! check daily output
    if (year > 5 .and. flag_cohoutd .ge. 1) then
       write(*,*) '  Warning: Your choice of daily output is ON with a simulation time of'
       write(*,'(I6,A,I8,A)') year,'  years. This option will create ',365*year,' data records per file!'
       write(*,'(A)',advance='no') '  Do you really want do use daily output (y/n)? '
       read *,a
       IF (a .eq. 'n' .or. a .eq. 'N') then
          flag_cohoutd = 0
       ENDIF
    ENDIF
 else
   if (flag_cohouty .eq. 0) flag_cohout = 0
   outcd%out_flag = 0
 endif

END SUBROUTINE UpdateCohdOut

!***************************************************************

